<!--
 * @Description: 新增/编辑弹框
 * @Author: Sugar.
 * @Date: 2023-11-24 13:55:00
 * @LastEditors: Sugar.
 * @LastEditTime: 22023-11-24 13:55:00
 * @FilePath: \cattle_webui\src\views\team\teamMr\AddOrEditDialog.vue
 * @Copyright: Copyright (c) 2016~2023 by Sugar., All Rights Reserved.
-->
<template>
  <el-dialog
    :title="title"
    :visible.sync="open"
    width="700px"
    append-to-body
    :close-on-click-modal="false"
    @close="cancel"
  >
    <div class="dialog">
      <el-form :model="form" ref="form" :rules="rules" label-width="120px">
        <el-form-item label="团队名称:" prop="name">
          <el-input
            v-model="form.name"
            placeholder="团队名称"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="团队类型:" prop="type">
          <el-select
            v-model="form.type"
            placeholder="团队类型"
            clearable
            style="width: 100%;"
          >
            <el-option
              v-for="dict in dict.type.team_type"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="负责人:" prop="contact">
          <el-input
            v-model="form.contact"
            placeholder="负责人"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="账号/联系电话:" prop="mobile">
          <el-input
            v-model="form.mobile"
            placeholder="账号/联系电话"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="密码">
          <el-input
            show-password
            v-model="form.password"
            autocomplete="new-password"
            placeholder="密码"
            clearable
            style="width: 100%;"
          />
        </el-form-item>
        <el-form-item label="合约信息:">
          <el-upload
            ref="upload"
            :action="uploadObj.url"
            :headers="uploadObj.headers"
            accept=".jpg,.png"
            :on-success="handlePhotoListSuccess"
            :before-upload="beforeAvatarUpload"
            list-type="picture-card"
            :file-list="form.photoList"
            :on-remove="handleRemove"
          >
            <i class="el-icon-plus"></i>
          </el-upload>
        </el-form-item>
      </el-form>
    </div>
    <span slot="footer" class="dialog-footer">
      <el-button @click="cancel">取消</el-button>
      <el-button
        type="primary"
        @click="submitForm"
        v-loading.fullscreen.lock="loading"
        element-loading-text="提交中..."
        element-loading-spinner="el-icon-loading"
        element-loading-background="rgba(0, 0, 0, 0.8)"
      >
        <span v-if="loading">提交中...</span>
        <span v-else>保存</span>
      </el-button>
    </span>
  </el-dialog>
</template>

<script>
// import { updateNoticeMgr } from "@/api/system/noticeMgr";
import { saveAndEdit, getSelectById } from "@/api/team/teamMr";
import Editor from "@/components/Editor";
import { getToken } from "@/utils/auth";
export default {
  name: "addAndEdit",
  props: {
    dict: {
      type: Object,
      default: () => [],
    },
  },
  components: {
    Editor,
  },
  data() {
    return {
      title: "编辑",
      model: "EDIT",
      activeName: '01',
      open: false,
      loading: false,
      form: {
        id: undefined,
        type: "",
      },
      rules: {
        name: [{ required: true, message: "请输入团队名称", trigger: ["change","blur"] }],
        type: [{ required: true, message: "请选择团队类型", trigger: ["change","blur"] }],
        contact: [{ required: true, message: "请输入负责人", trigger: ["change","blur"] }],
        mobile: [{ required: true, message: "请输入账号/联系电话", trigger: ["change","blur"] }],
      },
      uploadObj: {
        url: process.env.VUE_APP_UPLOAD_FILE_API + "/upload/single/minio",
        Headers: { Authorization: "Bearer " + getToken() },
      },
    };
  },
  methods: {
    /**
     * 打开弹框
     * @date 2023-11-22
     * @param {any} obj
     * @returns {any}
     */
    openDialog(title, obj) {
      this.open = true;
      this.reset();
      if (obj){
        this.title = "编辑团队";
        this.getSelectByIdApi(obj);
      }else{
        this.title = "添加团队";
        this.$nextTick(() => {
          this.$refs["form"].clearValidate();
        });
      }
    },
    /** 获取详情 */
    getSelectByIdApi(row) {
      const id = row.id
      getSelectById(id).then(response => {
        const obj = response.data;
        this.$nextTick(() => {
          this.$nextTick(() => {
            this.$set(this.form, 'id', obj.id);
            this.$set(this.form, 'name', obj.name);
            this.$set(this.form, 'type', obj.type + '');
            this.$set(this.form, 'contact', obj.contact);
            this.$set(this.form, 'password', "");
            this.$set(this.form, 'mobile', obj.mobile);
            if(obj.contractImg){
              if(obj.contractImg.indexOf(',') > -1){
                let img_list = obj.contractImg.split(',');
                let img_list_new = [];
                img_list.forEach((item, index) => {
                  img_list_new.push({
                    url: item,
                  })
                });
                this.$set(this.form, 'photoList', img_list_new);
              } else {
                this.$set(this.form, 'photoList', [{url: obj.contractImg}]);
              }
            } else {
              this.$set(this.form, 'photoList', []);
            }
          });
        });
      });
    },
    /**
     * 保存
     * @date 2023-11-22
     * @returns {any}
     */
    submitForm() {
      this.$refs["form"].validate(async (valid) => {
        if (valid) {
          try {
            this.loading = true;
            this.form.contractImg = '';
            this.form.photoList.forEach((item, index) => {
              if(index < this.form.photoList.length - 1) {
                this.form.contractImg += item.url + ",";
              } else {
                this.form.contractImg += item.url;
              }
            })
            const { code } = await saveAndEdit({ ...this.form });
            if (code === 200) {
              this.$message.success("操作成功!");
              this.$emit("getList");
              this.cancel();
            }
          } catch (error) {
          } finally {
            this.loading = false;
          }
        }
      });
    },
    /**
     * 重置
     * @date 2023-11-22
     * @returns {any}
     */
    reset() {
      this.$set(this.form, 'id', "");
      this.$set(this.form, 'name', "");
      this.$set(this.form, 'type', "");
      this.$set(this.form, 'contact', "");
      this.$set(this.form, 'password', "");
      this.$set(this.form, 'mobile', "");
      this.$set(this.form, 'photoList', []);
    },
    /**
     * 关闭弹框
     * @date 2023-11-22
     * @returns {any}
     */
    cancel() {
      this.reset();
      this.open = false;
    },
    /**
     * 上传成功
     * @date 2023-11-22
     * @param {any} res
     * @returns {any}
     */
    handleAvatarSuccess(res) {
      if (res.code === 200) {
        // this.form.mainImg = res?.data?.url;
        this.$set(this.form, 'mainImg', res?.data?.url)
      }
    },
    /**
     * 上传文件之前之前
     * @date 2023-11-22
     * @param {any} file
     * @returns {any}
     */
    beforeAvatarUpload(file) {
      const isJPG = file.type === "image/jpeg" || "image/png";
      if (!isJPG) {
        this.$message.error("上传头像图片只能是jpg或png格式!");
      }
      return isJPG;
    },
    /**
     * 剧目海报上传成功
     * @date 2023-11-22
     * @param {any} res
     * @returns {any}
     */
    handlePhotoListSuccess(res) {
      if (res.code === 200) {
        let photo = {
          imageUrl: res?.data?.url,
          url: res?.data?.url,
          photoType: '2'
        }
        if(!this.form.photoList){
          this.form.photoList = []
        }
        // this.form.photoList.push(photo);
        this.$set(this.form.photoList, this.form.photoList.length, photo);
      }
    },
    handleRemove(file, fileList) {
      this.form.photoList.forEach((item, index) => {
        if(item.uid == file.uid){
          this.form.photoList.splice(index, 1)
        }
      })
    },
  },
};
</script>

<style lang="scss" scoped>
.dialog {
  padding: 0 30px;
  max-height: 65vh;
  overflow-y: auto;
}
.dialog {
  padding: 0 30px;
  .upload-btn {
    width: 100px;
    height: 100px;
    background-color: #fbfdff;
    border: dashed 1px #c0ccda;
    border-radius: 5px;
    i {
      font-size: 30px;
      margin-top: 20px;
    }
    &-text {
      margin-top: -10px;
    }
  }
  .avatar {
    cursor: pointer;
  }
}
</style>
